# not available in binutils-2.27
%global build_hexagon		0
%global build_unicore32		0

# Do not create deterministic archives by default  (cf: BZ 1195883)
%global enable_deterministic_archives 0

# Disable the default generation of compressed debug sections.
%define default_compress_debug 0

# Default to read-only-relocations (relro) in shared binaries.
%define default_relro 1

# Disable the default generation of GNU Build notes by the assembler.
# This has turned out to be problematic for the i686 architecture.
# although the exact reason has not been determined.  (See BZ 1572485)
# It also breaks building EFI binaries on AArch64, as these cannot have
# relocations against absolute symbols.
%define default_generate_notes 0

Summary: Cross binutils for the bpf-unknown-none target
Name: bpf-binutils
Version: 2.30
Release: 2%{?dist}
License: GPLv3+
URL: https://sourceware.org/binutils

# Note - the Linux Kernel binutils releases are too unstable and contain too
# many controversial patches so we stick with the official FSF version
# instead.

Source: http://ftp.gnu.org/gnu/binutils/binutils-%{version}.tar.xz

Source2: binutils-2.19.50.0.1-output-format.sed

%if %{with docs}
# Strictly speaking this next file is not part of the binutils distribution.
# But the emacs info system expects it to be present on any system where
# emacs is installed, and old binutils distributions used to include it by
# mistake.  Since there is no suitable documentation files component to
# current RHEL releases, it is included here instead.  In order to save time
# and complexity it is stored as a pre-built, compressed, info file.
# The upstream version of the original source file can be found here:
#   http://git.savannah.gnu.org/gitweb/?p=gnulib.git;a=blob_plain;f=doc/standards.texi;hb=HEAD
# For more information see: https://bugzilla.redhat.com/show_bug.cgi?id=1467390
Source3: standards.info.gz
%endif

#----------------------------------------------------------------------------

# Purpose:  Use /lib64 and /usr/lib64 instead of /lib and /usr/lib in the
#           default library search path of 64-bit targets.
# Lifetime: Permanent, but it should not be.  This is a bug in the libtool
#           sources used in both binutils and gcc, (specifically the
#           libtool.m4 file).  These are based on a version released in 2009
#           (2.2.6?) rather than the latest version.  (Definitely fixed in
#           libtool version 2.4.6).
Patch01: binutils-2.20.51.0.2-libtool-lib64.patch

# Purpose:  Appends a RHEL or Fedora release string to the generic binutils
#           version string.
# Lifetime: Permanent.  This is a RHEL/Fedora specific patch.
Patch02: binutils-2.25-version.patch

# Purpose:  Exports the demangle.h header file (associated with the libiberty
#           sources) with the binutils-devel rpm.
# Lifetime: Permanent.  This is a RHEL/Fedora specific patch.
Patch03: binutils-2.22.52.0.1-export-demangle.h.patch

# Purpose:  Disables the check in the BFD library's bfd.h header file that
#           config.h has been included before the bfd.h header.  See BZ
#           #845084 for more details.
# Lifetime: Permanent - but it should not be.  The bfd.h header defines
#           various types that are dependent upon configuration options, so
#           the order of inclusion is important.
# FIXME:    It would be better if the packages using the bfd.h header were
#           fixed so that they do include the header files in the correct
#           order.
Patch04: binutils-2.22.52.0.4-no-config-h-check.patch

# Purpose:  Import H.J.Lu's Kernel LTO patch.
# Lifetime: Permanent, but needs continual updating.
# FIXME:    Try removing....
Patch05: binutils-2.26-lto.patch

# Purpose:  Include the filename concerned in readelf error messages.  This
#           makes readelf's output more helpful when it is run on multiple
#           input files.
# Lifetime: Permanent.  This patch changes the format of readelf's output,
#           making it better (IMHO) but also potentially breaking tools that
#           depend upon readelf's current format.  Hence it remains a local
#           patch.
Patch06: binutils-2.29-filename-in-error-messages.patch

# Purpose:  Use the "unsigned long long" type for pointers on hosts where
#           long is a 32-bit type but pointers are a 64-bit type.  Necessary
#           because the rpmdiff tester insists that if both the i686 and
#           x86_64 versions of binutils-devel are installed on the same
#           machine, then they will have identical versions of the bfd.h
#           header file.
# Lifetime: Permanent.
Patch07: binutils-2.25-set-long-long.patch

# Purpose:  Changes readelf so that when it displays extra information about
#           a symbol, this information is placed at the end of the line.
# Lifetime: Permanent.
# FIXME:    The proper fix would be to update the scripts that are expecting
#           a fixed output from readelf.  But it seems that some of them are
#           no longer being maintained.
Patch08: binutils-readelf-other-sym-info.patch

# Purpose:  Do not create PLT entries for AARCH64 IFUNC symbols referenced in
#           debug sections.
# Lifetime: Permanent.
# FIXME:    Find related bug.  Decide on permanency.
Patch09: binutils-2.27-aarch64-ifunc.patch

# Purpose:  Remove support for inserting PowerPC Speculation Barrier
#           instructions from the linker.  (It has been deprecated in
#           favour of a hardware fix).
# Lifetime: Fixed in 2.30.1 and/or 2.31.
Patch10: binutils-revert-PowerPC-speculation-barriers.patch

# Purpose:  Stop readelf/objdump for searching for DWO links unless
#           explicitly requested by the user.
# Lifetime: Fixed in 2.30.1 and/or 2.31.
Patch11: binutils-skip-dwo-search-if-not-needed.patch

# Purpose:  Fix a bug in the BFD linker's layout algorithm which ended up
#           placing executable and non-executable pages in the same segment.
# Lifetime: Fixed in 2.30.1 and/or 2.31.
Patch12: binutils-page-to-segment-assignment.patch

# Purpose:  Fix a bug in ld for linking against AARCH64 UEFI
# Lifetime: Fixed in 2.30.1 and/or 2.31
Patch13: binutils-2.30-allow_R_AARCH64-symbols.patch

# Purpose:  Stop strip from replacing unknown relocs with null relocs.  Make
#           it return an error status and not strip the file instead.
# Lifetime: Fixed in 2.31.
Patch14: binutils-strip-unknown-relocs.patch

# Purpose:  Improves objdump's function for locating a symbol to match a
#           given address, so that it uses a binary chop algorithm.
# Lifetime: Fixed in 2.31.
Patch15: binutils-speed-up-objdump.patch

# Purpose:  Ignore duplicate indirect symbols generated by GOLD.
# Lifetime: Permanent.
# FIXME:    This problem needs to be resolved in the FSF sources, but the
#           GOLD maintainers seem to be reluctant to address the issue.
Patch16: binutils-2.28-ignore-gold-duplicates.patch

# Purpose:  Treat relocs against STT_GNU_IFUNC symbols in note sections as
#           if they were relocs against STT_FUNC symbols instead.
# Lifetime: Fixed in 2.31.
Patch17: binutils-ifunc-relocs-in-notes.patch

# Purpose:  Do not discard debug only object files created by GCC v8's
#           LTO wrapper.
# Lifetime: Fixed in 2.31.
Patch18: binutils-debug-section-marking.patch

# Purpose:  Fix the GOLD linker's handling of PROTECTED symbols from the
#           LLVM plugin.
# Lifetime: Fixed in 2.31 (probably - check...).
Patch19: binutils-gold-llvm-plugin.patch

# Purpose:  Enhance the assembler so that it will automatically generate
#           GNU Build attribute notes if none are present in the inputs.
# Lifetime: Fixed in 2.31
Patch20: binutils-gas-build-notes.patch

# Purpose:  Fix a seg-fault triggered by running objdump on a corrupt AOUT
#           format file.
# Lifetime: Fixed in 2.31
Patch21: binutils-CVE-2018-7642.patch

# Purpose:  Fix a seg-fault triggered by running readelf or objdump on a
#           file containing corrupt DWARF debug information.
# Lifetime: Fixed in 2.31
Patch22: binutils-CVE-2018-7643.patch

# Purpose:  Fix a seg-fault triggered by running objdump on a corrupt COFF
#           format file.
# Lifetime: Fixed in 2.31
Patch23: binutils-CVE-2018-7208.patch

# Purpose:  Fix a seg-fault triggered by running readelf or objdump on a
#           file containing corrupt DWARF debug information.
# Lifetime: Fixed in 2.31
Patch24: binutils-CVE-2018-10372.patch

# Purpose:  Fix another seg-fault triggered by running readelf or objdump on a
#           file containing corrupt DWARF debug information.
# Lifetime: Fixed in 2.31
Patch25: binutils-CVE-2018-10373.patch

# Purpose:  Fix a seg-fault triggered by running objcopy on a corrupt ELF
#           file.
# Lifetime: Fixed in 2.31
Patch26: binutils-CVE-2018-7570.patch

# Purpose:  Fix a seg-fault triggered by running objcopy on a large ELF
#           file on a 32-bit host machine.
# Lifetime: Fixed in 2.31
Patch27: binutils-CVE-2018-6323.patch

# Purpose:  Fix a seg-fault triggered by running nm on a corrupt ELF file.
# Lifetime: Fixed in 2.31
Patch28: binutils-CVE-2018-6759.patch

# Purpose:  Fix a seg-fault triggered by running nm on a file containing
#           corrupt DWARF information.
# Lifetime: Fixed in 2.31
Patch29: binutils-CVE-2018-7569.patch

# Purpose:  Fix a seg-fault triggered by running nm on a file containing
#           corrupt DWARF information.
# Lifetime: Fixed in 2.31
Patch30: binutils-CVE-2018-7568.patch

# Purpose:  Fix a seg-fault triggered by running objcopy on a corrupt
#           PE format file.
# Lifetime: Fixed in 2.31
Patch31: binutils-CVE-2018-10534.patch

# Purpose:  Fix a seg-fault triggered by running objcopy on a corrupt
#           ELF format file.
# Lifetime: Fixed in 2.31
Patch32: binutils-CVE-2018-10535.patch

# Purpose:  Have the x86 linker resolve relocations against the _end,
#           __bss_start and -edata symbols locally.
# Lifetime: Fixed in 2.31
Patch33: binutils-x86-local-relocs.patch

# Purpose:  Stop the assembler from generating GNU build notes against
#           linkonce sections.
# Lifetime: Fixed in 2.31
Patch34: binutils-linkonce-notes.patch

# Purpose:  Fix a seg-fault triggered by running objcopy on a corrupt
#           PE format file.
# Lifetime: Fixed in 2.31
Patch35: binutils-CVE-2018-8945.patch

# Purpose:  Fix handling of local version symbols by the x86 linker.
# Lifetime: Fixed in 2.31
Patch36: binutils-x86-local-version.patch

# Purpose:  Fix linker testsuite failures
# Lifetime: Fixed in 2.31 (probably)
Patch37: binutils-fix-testsuite-failures.patch

# Purpose:  Correct warning messages about incompatible PowerPC IEEE
#           long double sizes in different binaries.
# Lifetime: Fixed in 2.31.
Patch38: binutils-PowerPC-IEEE-long-double-warnings.patch

# Purpose:  Fix the generation of relocations for assembler generated notes.
# Lifetime: Fixed in 2.31.
Patch39: binutils-missing-notes.patch

# Purpose:  Fix the gold linker so that it can handle note sections with
#           relocs that refer to discarded code sections.
# Lifetime: Fixed in 2.32 (maybe).
Patch40: binutils-gold-ignore-discarded-note-relocs.patch

# Purpose:  Merge .gnu.build.attribute sections into a single section.
# Lifetime: Fixed in 2.32
Patch41: binutils-merge-attribute-sections.patch

# Purpose:  Remove empty x86 property notes.
# Lifetime: Fixed in 2.31
Patch42: binutils-remove-empty-ISA-properties.patch

# Purpose:  Improve objcopy's --merge-notes option.
# Lifetime: Fixed in 2.32
Patch43: binutils-note-merge-improvements.patch

# Purpose:  Fix GOLDs creation of note segments.
# Lifetime: Fixed in 2.31  [Note - see chmod +x below for this patch].
Patch44: binutils-gold-note-segment.patch

# Purpose:  Stop readelf's reports of gaps in build notes - they are unreliable.
# Lifetime: Unknown.
Patch45: binutils-disable-readelf-gap-reports.patch

# Purpose:  Stop the x86_64 linker from optimizing away PLT entries.
# Lifetime: Probably fixed by new configure option in 2.32
Patch46: binutils-x86_64-disable-PLT-elision.patch

# Purpose:  Stop the binutils from statically linking with libstdc++.
# Lifetime: Permanent.
Patch47: binutils-do-not-link-with-static-libstdc++.patch

# Purpose:  Add a .attach_to_group pseudo-op to the assembler for
#           use by the annobin gcc plugin.
# Lifetime: Permanent.
Patch48: binutils-attach-to-group.patch

# Purpose:  Fix a potential buffer overrun when parsing a corrupt ELF file.
# Lifetime: Fixed in 2.32.
Patch49: binutils-CVE-2018-17358.patch

# Purpose:  Make the x86_64 linker produce IBT-enabled TLS stubs.
# Lifetime: Fixed in 2.32.
Patch50: binutils-x86_64-ibt-enabled-tlsdesc.patch

# Purpose:  Have the GOLD linker generate PT_NOTE segments with 8-byte alignment.
# Lifetime: Maybe fixed in 2.32.
Patch51: binutils-gold-8-byte-note-segments.patch

# Purpose:  Add support for disassembling NFP binaries.
# Lifetime: Fixed in 2.31.
Patch52: binutils-nfp.patch

# Purpose:  Add support for the arch13 extension to the s390x architecture.
# Lifetime: Fixed in 2.31.
Patch53: binutils-s390x-arch13.patch

# Purpose:  Add support for partially relocatable GOT sections on the s390x architecture.
# Lifetime: Fixed in 2.31.
Patch54: binutils-s390x-partial-relro.patch

# Purpose:  Do not enable IBT if an object file contains code but no GNU Property notes.
# Lifetime: Fixed in 2.33
Patch55: binutils-x86-IBT-and-missing-notes.patch

# Purpose:  Fixes a problem with the AArch64 port of the GOLD linker.
# Lifetime: Fixed in 2.32
Patch56: binutils-AArch64-gold.patch

# Purpose:  Stop the BFD library from complaining about files with multiple
#           relocations against the same section.  Allows examination of
#           special kernel modules.
# Lifetime: Fixed in 2.33
Patch57: binutils-multiple-relocs-for-same-section.patch

#----------------------------------------------------------------------------

# Oracle Patches
Patch200: binutils-aarch64-stub-alignment.patch
Patch201: binutils-2.30-bpf.patch

#----------------------------------------------------------------------------

BuildRequires: texinfo >= 4.0, gettext, flex, bison, zlib-devel
# BZ 920545: We need pod2man in order to build the manual pages.
BuildRequires: /usr/bin/pod2man
# Perl, sed and touch are all used in the %prep section of this spec file.
BuildRequires: gcc, perl, sed, coreutils
BuildRequires: findutils
 
# Required for: ld-bootstrap/bootstrap.exp bootstrap with --static
# It should not be required for: ld-elf/elf.exp static {preinit,init,fini} array
Conflicts: gcc-c++ < 4.0.0
%ifarch ia64
Obsoletes: gnupro <= 1117-1
%endif
Provides: bundled(libiberty)

%description
Binutils is a collection of binary utilities, including ar (for
creating, modifying and extracting from archives), as (a family of GNU
assemblers), gprof (for displaying call graph profile data), ld (the
GNU linker), nm (for listing symbols from object files), objcopy (for
copying and translating object files), objdump (for displaying
information from object files), ranlib (for generating an index for
the contents of an archive), readelf (for displaying detailed
information about binary files), size (for listing the section sizes
of an object or archive file), strings (for listing printable strings
from files), strip (for discarding symbols), and addr2line (for
converting addresses to file and line).

%package -n binutils-bpf-unknown-none
Summary: Cross-build binary utilities for bpf-unknown-none
%description -n binutils-bpf-unknown-none
Cross-build binary image generation, manipulation and query tools.

# Where the binaries aimed at gcc will live (ie. /usr/<target>/bin/)
%global auxbin_prefix %{_exec_prefix}

###############################################################################
#
# Preparation
#
###############################################################################
%prep

%global srcdir binutils-%{version}
%setup -q -n %{srcdir} -c
cd %{srcdir}
%patch01 -p1
%patch02 -p1
%patch03 -p1
%patch04 -p1
%patch06 -p1
%patch07 -p1
%patch08 -p1
%patch09 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1
%patch37 -p1
%patch38 -p1
%patch39 -p1
%patch40 -p1
%patch41 -p1
%patch42 -p1
%patch43 -p1
%patch44 -p1
%patch45 -p1
%patch46 -p1
%patch47 -p1
%patch48 -p1
%patch49 -p1
%patch50 -p1
%patch51 -p1
%patch52 -p1
%patch53 -p1
%patch54 -p1
%patch55 -p1
%patch56 -p1
%patch57 -p1

# Oracle Patches
%patch200 -p1
%patch201 -p2

# We cannot run autotools as there is an exact requirement of autoconf-2.59.

# On ppc64 and aarch64, we might use 64KiB pages
sed -i -e '/#define.*ELF_COMMONPAGESIZE/s/0x1000$/0x10000/' bfd/elf*ppc.c
sed -i -e '/#define.*ELF_COMMONPAGESIZE/s/0x1000$/0x10000/' bfd/elf*aarch64.c
sed -i -e '/common_pagesize/s/4 /64 /' gold/powerpc.cc
sed -i -e '/pagesize/s/0x1000,/0x10000,/' gold/aarch64.cc
# LTP sucks
perl -pi -e 's/i\[3-7\]86/i[34567]86/g' */conf*
sed -i -e 's/%''{release}/%{release}/g' bfd/Makefile{.am,.in}
sed -i -e '/^libopcodes_la_\(DEPENDENCIES\|LIBADD\)/s,$, ../bfd/libbfd.la,' opcodes/Makefile.{am,in}
# Build libbfd.so and libopcodes.so with -Bsymbolic-functions if possible.
if gcc %{optflags} -v --help 2>&1 | grep -q -- -Bsymbolic-functions; then
sed -i -e 's/^libbfd_la_LDFLAGS = /&-Wl,-Bsymbolic-functions /' bfd/Makefile.{am,in}
sed -i -e 's/^libopcodes_la_LDFLAGS = /&-Wl,-Bsymbolic-functions /' opcodes/Makefile.{am,in}
fi
# $PACKAGE is used for the gettext catalog name.
sed -i -e 's/^ PACKAGE=/ PACKAGE=bpf-/' */configure
# Undo the name change to run the testsuite.
for tool in binutils gas ld
do
  sed -i -e "2aDEJATOOL = $tool" $tool/Makefile.am
  sed -i -e "s/^DEJATOOL = .*/DEJATOOL = $tool/" $tool/Makefile.in
done
touch */configure

echo bpf-unknown-none 5>target.list

###############################################################################
#
# Build
#
###############################################################################
%build

# Configure the bpf target

target=bpf-unknown-none
prefix=$target-
build_dir=bpf

export CFLAGS="$RPM_OPT_FLAGS"
CARGS=

%if %{default_relro}
  CARGS="$CARGS --enable-relro=yes"
%else
  CARGS="$CARGS --enable-relro=no"
%endif

mkdir $build_dir
cd $build_dir

# We could optimize the cross builds size by --enable-shared but the produced
# binaries may be less convenient in the embedded environment.
echo LDFLAGS: $RPM_LD_FLAGS
LDFLAGS="$RPM_LD_FLAGS " \
../%{srcdir}/configure \
	--disable-dependency-tracking \
	--disable-silent-rules \
	--enable-checking \
	--prefix=%{_prefix} \
	--exec-prefix=%{auxbin_prefix} \
	--bindir=%{_bindir} \
	--sbindir=%{_sbindir} \
	--sysconfdir=%{_sysconfdir} \
	--datadir=%{_datadir} \
	--includedir=%{_includedir} \
	--libdir=%{_libdir} \
	--libexecdir=%{_libexecdir} \
	--localstatedir=%{_localstatedir} \
	--sharedstatedir=%{_sharedstatedir} \
	--mandir=%{_mandir} \
	--infodir=%{_infodir} \
	--build=%{_target_platform} \
	--host=%{_target_platform} \
	--target=$target \
	--program-prefix=$prefix \
	--disable-shared \
	--disable-install_libbfd \
	--with-sysroot=%{_prefix}/$arch/sys-root \
%if %{enable_deterministic_archives}
	--enable-deterministic-archives \
%else    
	--enable-deterministic-archives=no \
%endif
%if %{default_compress_debug}
	--enable-compressed-debug-sections=all \
%else
	--enable-compressed-debug-sections=none \
%endif
%if %{default_generate_notes}
	--enable-generate-build-notes=yes \
%else
	--enable-generate-build-notes=no \
%endif
	--enable-lto \
	$CARGS \
	--enable-plugins \
	--with-bugurl=http://bugzilla.redhat.com/bugzilla/
cd ..

# Build the bpf target

build_dir=bpf
%make_build -C $build_dir tooldir=%{_prefix} all
 
###############################################################################
#
# Installation
#
###############################################################################
%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{_prefix}/$target/sys-root
cpu=bpf
build_dir=bpf
%make_install -C $build_dir DESTDIR=%{buildroot}

# echo "=== INSTALL man targets ==="
# make install-man1 -C %{cross}-binutils/binutils/doc DESTDIR=%{buildroot}
# make install-man1 -C %{cross}-binutils/gas/doc DESTDIR=%{buildroot}
# make install-man1 -C %{cross}-binutils/ld DESTDIR=%{buildroot}
# make install-man1 -C %{cross}-binutils/gprof DESTDIR=%{buildroot}

# echo "=== INSTALL po targets ==="
# %make_install -C %{cross}-binutils/binutils/po DESTDIR=%{buildroot}
# %make_install -C %{cross}-binutils/gas/po DESTDIR=%{buildroot}
# %make_install -C %{cross}-binutils/ld/po DESTDIR=%{buildroot}
# %make_install -C %{cross}-binutils/gprof/po DESTDIR=%{buildroot}
# %make_install -C %{cross}-binutils/bfd/po DESTDIR=%{buildroot}
# %make_install -C %{cross}-binutils/opcodes/po DESTDIR=%{buildroot}

# Drop the documentation.
echo "=== REMOVE documentation ==="
rm -rf %{buildroot}%{_infodir}
rm -f %{buildroot}%{_infodir}/dir

# echo "=== REMOVE libraries and scripts ==="
rm -rf %{buildroot}%{_libdir}/libiberty.a
rm -rf %{buildroot}%{auxbin_prefix}/*/lib/ldscripts
rmdir %{buildroot}%{auxbin_prefix}/*/lib || :

# Build the file list

arch=bpf-unknown-none
cpu=bpf

(
  echo %{_bindir}/$arch-[!l]\*
  echo %{_bindir}/$arch-ld\*
  echo %{_mandir}/man1/$arch-\*
  echo %{auxbin_prefix}/$cpu-\*
  # i18n
  %find_lang bpf-binutils
  %find_lang bpf-opcodes
  %find_lang bpf-bfd
  %find_lang bpf-gas
  %find_lang bpf-ld
  %find_lang bpf-gprof
  cat bpf-binutils.lang
  cat bpf-opcodes.lang
  cat bpf-bfd.lang
  cat bpf-gas.lang
  cat bpf-ld.lang
  cat bpf-gprof.lang
) >files.$arch

# Add ld.bfd manual pages
find * -name "*ld.1*" -a ! -name "bpf-ld.1*" -print |
while read x
do
    y=`echo $x | sed -e s/ld[.]1/ld.bfd.1/`
    ln -s $x $y
done

cd -

###############################################################################
#
# Cleanup
#
###############################################################################
###############################################################################
#
# Filesets
#
###############################################################################

%files -n binutils-bpf-unknown-none -f files.bpf-unknown-none
%doc %{srcdir}/README
%doc %{srcdir}/COPYING*

%changelog
* Wed Apr 22 2020 David Faust <david.faust@oracle.com> - 2.30-2
- Fix missing BPF JMP32 instruction class.
- Backport from upstream commit c54a9b56696e584c2b8c7146caac337c063f5516.
- Reviewed-by: Jose E. Marchesi <jose.marchesi@oracle.com>

* Mon Dec  9 2019 Jose E. Marchesi <jose.marchesi@oracle.com> - 2.30-1
- New package.
